# Uses of Class
org.apache.zookeeper.server.ServerCnxn

Packages that use ServerCnxn
Package
Description
org.apache.zookeeper.server
ZooKeeper server theory of operation
org.apache.zookeeper.server.auth
org.apache.zookeeper.server.command
org.apache.zookeeper.server.controller
org.apache.zookeeper.server.quorum

## Uses of ServerCnxn in org.apache.zookeeper.server

Subclasses of ServerCnxn in org.apache.zookeeper.server
Modifier and Type
Class
Description
`class`
`DumbWatcher`
A empty watcher implementation used in bench and unit test.
`class`
`NettyServerCnxn`
`class`
`NIOServerCnxn`
This class handles communication with clients using NIO.
Fields in org.apache.zookeeper.server declared as ServerCnxn
Modifier and Type
Field
Description
`final ServerCnxn`
Request.`cnxn`
Fields in org.apache.zookeeper.server with type parameters of type ServerCnxn
Modifier and Type
Field
Description
`protected final Set<ServerCnxn>`
ServerCnxnFactory.`cnxns`
Methods in org.apache.zookeeper.server that return ServerCnxn
Modifier and Type
Method
Description
`ServerCnxn`
Request.`getConnection()`
Methods in org.apache.zookeeper.server that return types with arguments of type ServerCnxn
Modifier and Type
Method
Description
`Iterable<ServerCnxn>`
NettyServerCnxnFactory.`getConnections()`
`Iterable<ServerCnxn>`
NIOServerCnxnFactory.`getConnections()`
`abstract Iterable<ServerCnxn>`
ServerCnxnFactory.`getConnections()`
Methods in org.apache.zookeeper.server with parameters of type ServerCnxn
Modifier and Type
Method
Description
`void`
ServerCnxnFactory.`addSession(long sessionId, ServerCnxn cnxn)`
`void`
ZooKeeperServer.`checkACL(ServerCnxn cnxn, List<ACL> acl, int perm, List<Id> ids, String path, List<ACL> setAcls)`
Grant or deny authorization to an operation on a node as a function of:
`void`
ZooKeeperServer.`closeSession(ServerCnxn cnxn, RequestHeader requestHeader)`
`boolean`
AuthenticationHelper.`enforceAuthentication(ServerCnxn connection, int xid)`
Returns true when authentication enforcement was success otherwise returns false also closes the connection
`void`
ZooKeeperServer.`finishSessionInit(ServerCnxn cnxn, boolean valid)`
`void`
ZooKeeperServer.`processConnectRequest(ServerCnxn cnxn, ConnectRequest request)`
`void`
ZooKeeperServer.`processPacket(ServerCnxn cnxn, RequestHeader h, RequestRecord request)`
`void`
ServerCnxnFactory.`registerConnection(ServerCnxn serverCnxn)`
`void`
ZKDatabase.`removeCnxn(ServerCnxn cnxn)`
remove a cnxn from the datatree
`void`
ServerCnxnFactory.`removeCnxnFromSessionMap(ServerCnxn cnxn)`
`void`
ZooKeeperServer.`reopenSession(ServerCnxn cnxn, long sessionId, byte[] passwd, int sessionTimeout)`
`protected void`
ZooKeeperServer.`revalidateSession(ServerCnxn cnxn, long sessionId, int sessionTimeout)`
`Stat`
ZKDatabase.`statNode(String path, ServerCnxn serverCnxn)`
stat the path
`void`
ServerCnxnFactory.`unregisterConnection(ServerCnxn serverCnxn)`
`protected void`
ZooKeeperServer.`validateSession(ServerCnxn cnxn, long sessionId)`
Validate if a particular session can be reestablished.
Constructors in org.apache.zookeeper.server with parameters of type ServerCnxn
Modifier
Constructor
Description
``
`ConnectionBean(ServerCnxn connection, ZooKeeperServer zk)`
``
`Request(ServerCnxn cnxn, long sessionId, int xid, int type, RequestRecord request, List<Id> authInfo)`

## Uses of ServerCnxn in org.apache.zookeeper.server.auth

Methods in org.apache.zookeeper.server.auth that return ServerCnxn
Modifier and Type
Method
Description
`ServerCnxn`
ServerAuthenticationProvider.ServerObjs.`getCnxn()`
Methods in org.apache.zookeeper.server.auth with parameters of type ServerCnxn
Modifier and Type
Method
Description
`KeeperException.Code`
AuthenticationProvider.`handleAuthentication(ServerCnxn cnxn, byte[] authData)`
This method is called when a client passes authentication data for this scheme.
`KeeperException.Code`
DigestAuthenticationProvider.`handleAuthentication(ServerCnxn cnxn, byte[] authData)`
`KeeperException.Code`
EnsembleAuthenticationProvider.`handleAuthentication(ServerCnxn cnxn, byte[] authData)`
`KeeperException.Code`
IPAuthenticationProvider.`handleAuthentication(ServerCnxn cnxn, byte[] authData)`
`KeeperException.Code`
SASLAuthenticationProvider.`handleAuthentication(ServerCnxn cnxn, byte[] authData)`
`final KeeperException.Code`
ServerAuthenticationProvider.`handleAuthentication(ServerCnxn cnxn, byte[] authData)`
`KeeperException.Code`
X509AuthenticationProvider.`handleAuthentication(ServerCnxn cnxn, byte[] authData)`
Constructors in org.apache.zookeeper.server.auth with parameters of type ServerCnxn
Modifier
Constructor
Description
``
`ServerObjs(ZooKeeperServer zks, ServerCnxn cnxn)`

## Uses of ServerCnxn in org.apache.zookeeper.server.command

Fields in org.apache.zookeeper.server.command declared as ServerCnxn
Modifier and Type
Field
Description
`protected ServerCnxn`
AbstractFourLetterCommand.`serverCnxn`
Methods in org.apache.zookeeper.server.command with parameters of type ServerCnxn
Modifier and Type
Method
Description
`boolean`
CommandExecutor.`execute(ServerCnxn serverCnxn, PrintWriter pwriter, int commandCode, ZooKeeperServer zkServer, ServerCnxnFactory factory)`
This class decides which command to be executed and then executes
Constructors in org.apache.zookeeper.server.command with parameters of type ServerCnxn
Modifier
Constructor
Description
``
`AbstractFourLetterCommand(PrintWriter pw, ServerCnxn serverCnxn)`
``
`CnxnStatResetCommand(PrintWriter pw, ServerCnxn serverCnxn)`
``
`ConsCommand(PrintWriter pw, ServerCnxn serverCnxn)`
``
`DigestCommand(PrintWriter pw, ServerCnxn serverCnxn)`
``
`DirsCommand(PrintWriter pw, ServerCnxn serverCnxn)`
``
`DumpCommand(PrintWriter pw, ServerCnxn serverCnxn)`
``
`IsroCommand(PrintWriter pw, ServerCnxn serverCnxn)`
``
`NopCommand(PrintWriter pw, ServerCnxn serverCnxn, String msg)`
``
`RuokCommand(PrintWriter pw, ServerCnxn serverCnxn)`
``
`SetTraceMaskCommand(PrintWriter pw, ServerCnxn serverCnxn, long trace)`
``
`StatCommand(PrintWriter pw, ServerCnxn serverCnxn, int len)`
``
`StatResetCommand(PrintWriter pw, ServerCnxn serverCnxn)`
``
`WatchCommand(PrintWriter pw, ServerCnxn serverCnxn, int len)`

## Uses of ServerCnxn in org.apache.zookeeper.server.controller

Subclasses of ServerCnxn in org.apache.zookeeper.server.controller
Modifier and Type
Class
Description
`class`
`ControllableConnection`
Extension of NIOServerCnxn which can inject changes per controller commands.

## Uses of ServerCnxn in org.apache.zookeeper.server.quorum

Methods in org.apache.zookeeper.server.quorum with parameters of type ServerCnxn
Modifier and Type
Method
Description
`protected void`
LeaderZooKeeperServer.`revalidateSession(ServerCnxn cnxn, long sessionId, int sessionTimeout)`
`protected void`
LearnerZooKeeperServer.`revalidateSession(ServerCnxn cnxn, long sessionId, int sessionTimeout)`
`protected void`
ReadOnlyZooKeeperServer.`validateSession(ServerCnxn cnxn, long sessionId)`